<?php

namespace plugin\inspection\controller;

use plugin\inspection\model\InspectionRecord;
use think\admin\Controller;
use think\admin\helper\QueryHelper;

/**
 * 巡检记录
 */
class Record extends Controller
{
    /**
     * 巡检记录
     * @auth true
     * @menu true
     * @return void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function index()
    {
        $this->title = '巡检记录';
        InspectionRecord::mQuery()->layTable(function () {
        }, function (QueryHelper $query) {
            $query->dateBetween(['start_at','end_at'])->equal(['status'])->with(['staff'])->append(['status_text']);
        });
    }

    public function detail()
    {
        $id = $this->request->get('id');
        $record = InspectionRecord::query()->with(['points'])->where('id', $id)->findOrEmpty();
        if ($record->isEmpty()) $this->error('记录不存在');
        $this->vo = $record;
        $this->fetch();
    }

    /**
     * 状态修改
     * @auth true
     * @menu true
     * @return void
     */
    public function status()
    {
        InspectionRecord::mSave($this->_vali([
            'id.require' => '巡检记录ID不能为空',
            'status.in:0,1' => '状态值范围异常！',
            'status.require' => '状态值不能为空！',
        ]), 'id');
    }

    /**
     * 删除记录
     * @auth true
     * @menu true
     * @return void
     */
    public function delete()
    {
        InspectionRecord::mDelete('id');
    }
}